; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm     ; the macro file

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      includelib project.lib

    ; ----------------------------------------
    ; prototypes for local procedures go here
    ; ----------------------------------------

      tstdlg     PROTO :DWORD,:DWORD
      tstdlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

      exportproc PROTO :DWORD

      .data?
        hInstance dd ?

      .code

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 

    .if reason == DLL_PROCESS_ATTACH
      push instance
      pop hInstance
      mov eax, TRUE

    .elseif reason == DLL_PROCESS_DETACH

    .elseif reason == DLL_THREAD_ATTACH

    .elseif reason == DLL_THREAD_DETACH

    .endif

    ret

LibMain endp

; 

tstdlg proc Instance:DWORD,Parent:DWORD 

    Dialog "Test EXPORT Dialog Box in DLL", \      ; caption
           "MS Sans Serif",8, \             ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            2, \                            ; number of controls
            50,50,190,100, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "Call exe export",    WS_TABSTOP,120, 5,60,12,IDOK
    DlgButton "Close exe",WS_TABSTOP,120,19,60,12,IDCANCEL

    CallModalDialog Instance,Parent,tstdlgProc,ADDR Instance

    ret

tstdlg endp

; 

tstdlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    .if uMsg == WM_INITDIALOG
      invoke SendMessage,hWin,WM_SETICON,1,
                         FUNC(LoadIcon,NULL,IDI_APPLICATION)
    ; -------------------------------------
    ; return 1 to set focus to 1st control
    ; -------------------------------------
      mov eax, 1
      ret

    .elseif uMsg == WM_COMMAND
      .if wParam == IDOK
      invoke exportproc, 1
    ; ------------------------
    ; code for OK button here
    ; ------------------------
      .elseif wParam == IDCANCEL
        invoke exportproc, 2
      .endif

    .elseif uMsg == WM_CLOSE
      quit_dialog:
       invoke EndDialog,hWin,0

    .endif

    ; -------------------------------
    ; return zero for default action
    ; -------------------------------
    xor eax, eax
    ret

tstdlgProc endp

; 

end LibMain
